library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;
use work.ADD_nB;                

-- 2*NB_bits => NB_bits 
--

entity Arrondi is

generic(NB_BITS : integer := 12);
port(	Entree: in std_logic_vector(2*NB_BITS - 1 downto 0);
	   Reset: in std_logic;
	   Sortie: out std_logic_vector(NB_BITS - 1 downto 0));
	   
end Arrondi ;
    
architecture Arrondi_beh of Arrondi is

constant arrondi_N : std_logic_vector(2*NB_BITS - 1 downto 0) := (NB_BITS-1  =>'1', others =>'0');--"0000000010000000";--"00000000000000001000000000000000";--(NB_BITS-1  =>'1', others =>'0');
constant arrondi_P : std_logic_vector(2*NB_BITS - 1 downto 0) := (NB_BITS-2 downto 0  =>'1', others =>'0');--"0000000001111111";--"00000000000000000111111111111111";--(NB_BITS-2 downto 0  =>'1', others =>'0');
signal arrondi : std_logic_vector(2*NB_BITS - 1 downto 0) := (others => '0');
signal Sortie_inter_2NB_BITSbits: std_logic_vector (2*NB_BITS - 1 downto 0);
signal Sortie_inter : std_logic_vector (NB_BITS - 1 downto 0);

component ADD_nB is
	generic(NB_BITS : integer);
    port ( a,b 	 : in  std_logic_vector(NB_BITS-1 downto 0);
	   Reset : in std_logic;
           Sum   : out std_logic_vector(NB_BITS-1 downto 0)
          );
end component;

begin 

ADD_nB_1 : ADD_nB
generic map(NB_BITS=>2*NB_BITS)
port map(a=>Entree,b=>arrondi,Reset=>Reset,Sum=>Sortie_inter_2NB_BITSbits);
--port map(a=>Entree,b=>(others=>'0'),Reset=>Reset,Sum=>Sortie_inter_2NB_BITSbits);


	process (Entree, Sortie_inter_2NB_BITSbits,Sortie_inter,Reset)

	begin
		
		if reset = '1' then Sortie_inter <= (others => '0');
			arrondi <= (others =>'0');
		else 
			if Entree(2*NB_BITS-1)='1' then
				arrondi <= arrondi_N;
			else 
				arrondi <= arrondi_P;
			end if;

			Sortie_inter(NB_BITS - 1 downto 0) <= Sortie_inter_2NB_BITSbits(2*NB_BITS - 1 downto NB_BITS);
			
		end if;

		Sortie <= Sortie_inter;

	end process;


--   process(Entree,Reset)
--     variable Rinter : std_logic_vector(NB_BITS-1 downto 0);
--     Begin
--       if Reset = '1' then
--         Rinter := (others => '0');
--       else
--         Rinter := Entree(2*NB_BITS-1 downto NB_BITS);
--       end if;
--       Sortie <= Rinter;     
--   end process;

end Arrondi_beh;


