-- Declaration des bibliotheques -----
library ieee;
use ieee.std_logic_1164.all;

-- Entit ----------------------------
entity Bas_D_nB is
generic( NB_BITS : integer := 12);
port(	D: in std_logic_vector(NB_BITS - 1 downto 0);
	   Reset,CLK,En: in std_logic;
	   Q: out std_logic_vector(NB_BITS - 1 downto 0));
end Bas_D_nB;  

-- Architecture-----------------------
architecture Bas_D_nB_beh of Bas_D_nB is

signal Qtmp : std_logic_vector(NB_BITS - 1 downto 0);

begin 
	Q <= Qtmp;
    process(Reset,CLK)
    begin
        if Reset = '1' then 				
				Qtmp <= (others => '0');	 
        elsif CLK'event and CLK='1' then
			if (En ='1') then			
				Qtmp <= D;
			end if; 
        end if;
   end process; 
end Bas_D_nB_beh;

