library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;  
use ieee.std_logic_textio.all;  -- lecture et ecriture de fichiers

use std.textio.all;
use work.ADD_nB;                
use work.MUL_nB;
use work.DIFF_nB;
use work.Arrondi;


-- déclaration de l'entité
entity Calcul_wS is

generic(NB_BITS : integer := 12);
port(	mic_1,signal_est,x,w: in std_logic_vector(NB_BITS - 1 downto 0);
		mu : std_logic_vector(NB_BITS - 1 downto 0);
	   Reset : in std_logic;
	   Sortie: out std_logic_vector(NB_BITS - 1 downto 0)
		);
	   
end Calcul_wS ;
    
-- déclaration de l'architecture du testBench
architecture Calcul_wS_beh of Calcul_wS is
      
 -- déclaration des composants  
component ADD_nB is
	generic(NB_BITS : integer);
    port ( a,b 	 : in  std_logic_vector(NB_BITS-1 downto 0);
	   Reset : in std_logic;
           Sum   : out std_logic_vector(NB_BITS-1 downto 0)
          );
end component;

component MUL_nB is
	generic(NB_BITS : integer);
    port ( a,b 	 : in  std_logic_vector(NB_BITS-1 downto 0);
	   Reset : in std_logic;
           Prod   : out std_logic_vector(2*NB_BITS-1 downto 0)
          );
end component;


component DIFF_nB is
generic (NB_BITS : integer);
port(	a: in std_logic_vector(NB_BITS-1 downto 0);
	b   : in std_logic_vector(NB_BITS-1 downto 0);
	Reset : in std_logic;
	Diff : out std_logic_vector(NB_BITS-1 downto 0)
	);
end component;


component Arrondi is

generic(NB_BITS : integer);
port(	Entree: in std_logic_vector(2*NB_BITS - 1 downto 0);
	   Reset: in std_logic;
	   Sortie: out std_logic_vector(NB_BITS - 1 downto 0));
	   
end component;

signal e,mu_e,result_mult_NB_BITSbits,result_sum:std_logic_vector(NB_BITS - 1 downto 0);
signal result_mult,NB_BITSmu_e : std_logic_vector(2*NB_BITS - 1 downto 0);

begin 



DIFF_nB_1 : DIFF_nB 
generic map(NB_BITS)
port map(a=>mic_1 ,b=>signal_est,Reset=>Reset,Diff=> e);


decal_1 : MUL_nB
generic map(NB_BITS)
port map(a=>e,b=>mu,Reset=>Reset,Prod=>NB_BITSmu_e);


Arrondi_mu : Arrondi
generic map(NB_BITS)
port map(Entree=>NB_BITSmu_e,Reset=>Reset,Sortie=>mu_e);


MUL_nB_1 : MUL_nB
generic map(NB_BITS)
port map(a=>x,b=>mu_e,Reset=>Reset,Prod=>result_mult);

Arrondi_1 : Arrondi
generic map(NB_BITS)
port map(Entree=>result_mult,Reset=>Reset,Sortie=>result_mult_NB_BITSbits);

ADD_nB_1 : ADD_nB
generic map(NB_BITS=>NB_BITS)
port map(a=>result_mult_NB_BITSbits,b=>w,Reset=>Reset,Sum=>result_sum);

Sortie <= result_sum;

end Calcul_wS_beh;

