library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;  
use ieee.std_logic_textio.all;  -- lecture et ecriture de fichiers

use std.textio.all;
use work.ADD_nB;                
use work.MUL_nB;
use work.Bas_D_nB;

-- déclaration de l'entité
entity FIFO is

generic( NB_BITS : integer := 16;
			NB_COEFF : integer:= 12000);
port(	D: in std_logic_vector(NB_BITS - 1 downto 0);
	   Reset,CLK,En: in std_logic;
	   Q: out std_logic_vector(NB_BITS - 1 downto 0));
	   
end FIFO ;
    
-- déclaration de l'architecture du testBench
architecture FIFO_beh of FIFO is
      
 -- déclaration des composants  

component Bas_D_nB is
generic (NB_BITS : integer);
port(  D: in std_logic_vector(NB_BITS - 1 downto 0);
	   Reset,CLK,En: in std_logic;
	   Q: out std_logic_vector(NB_BITS - 1 downto 0));
end component;

type Data_FIFO_type is array (NB_COEFF - 1 downto 0) of std_logic_vector(NB_BITS-1 downto 0);
signal Data_FIFO : Data_FIFO_type;

--signal Data_FIFO : STD_LOGIC_VECTOR (NB_BITS - 2 downto 0);

begin 

  GEN_Bascule_D : for I in 0 to NB_COEFF-1 generate
	  G0: IF (I = 0) GENERATE
		Bas_D0 : Bas_D_nB generic map(NB_BITS)
								port map(D => D,Reset=>Reset,CLK=>CLK, En=>En,Q=>Data_FIFO(0));
		END GENERATE G0;
	  G1: IF (I > 0) and (I < NB_COEFF-1) GENERATE
		  Bas_D1 : Bas_D_nB generic map(NB_BITS)
								port map(D=>Data_FIFO(I-1), CLK=>CLK,En=>En, Reset=>Reset, Q => Data_FIFO(I));
		END GENERATE G1;
	  G2: if I = NB_COEFF-1 GENERATE
		  Bas_D2 : Bas_D_nB generic map(NB_BITS)
								port map(D=>Data_FIFO(I-1), CLK=>CLK,En=>En, Reset=>Reset, Q => Q);
		END GENERATE G2;
	   end generate GEN_Bascule_D;  
             
end FIFO_beh;