library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;  
use ieee.std_logic_textio.all;  -- lecture et ecriture de fichiers

use std.textio.all;
use work.ADD_nB;                
use work.MUL_nB;
use work.Bas_D_nB;


-- déclaration de l'entité
entity MAC is

generic( NB_BITS : integer:= 12);
port(	Entree1, Entree2: in std_logic_vector(NB_BITS - 1 downto 0);
	   Reset,CLK: in std_logic;
	   Sortie: out std_logic_vector(2*NB_BITS - 1 downto 0));
	   
end MAC ;
    
-- déclaration de l'architecture du testBench
architecture MAC_beh of MAC is
      
 -- déclaration des composants  
component ADD_nB is
	generic(NB_BITS : integer);
    port ( a,b 	 : in  std_logic_vector(NB_BITS-1 downto 0);
	   Reset : in std_logic;
           Sum   : out std_logic_vector(NB_BITS-1 downto 0)
          );
end component;

component MUL_nB is
	generic(NB_BITS : integer);
    port ( a,b 	 : in  std_logic_vector(NB_BITS-1 downto 0);
	   Reset : in std_logic;
           Prod   : out std_logic_vector(2*NB_BITS-1 downto 0)
          );
end component;


component Bas_D_nB is
generic (NB_BITS : integer);
port(	D: in std_logic_vector(NB_BITS - 1 downto 0);
	   Reset,CLK,EN: in std_logic;
	   Q: out std_logic_vector(NB_BITS - 1 downto 0));
end component;


signal result_mult, sum_mult, sum_mult_tmoins1  : std_logic_vector(2*NB_BITS - 1 downto 0);


begin 




Bas_D_nB_mult : Bas_D_nB 
generic map(NB_BITS=>2*NB_BITS)
port map(D=>sum_mult,Reset=>Reset,CLK=>CLK,EN=>'1', Q=>sum_mult_tmoins1);

MUL_nB_1 : MUL_nB
generic map(NB_BITS)
port map(a=>Entree1,b=>Entree2,Reset=>Reset,Prod=>result_mult);

ADD_nB_1 : ADD_nB
generic map(NB_BITS=>2*NB_BITS)
port map(a=>result_mult,b=>sum_mult_tmoins1,Reset=>Reset,Sum=>sum_mult);

Sortie <= sum_mult;

end MAC_beh;
