--------------------------------------
-- Additionneur nbit
--------------------------------------

-- Declaration des bibliotheques -----
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

-- Entit ----------------------------
entity ADD_nB is
	generic( NB_BITS : integer := 12);
	port(	a: in std_logic_vector(NB_BITS-1 downto 0);
			b   : in std_logic_vector(NB_BITS-1 downto 0);
			Reset : in std_logic;
			Sum : out std_logic_vector(NB_BITS-1 downto 0));
end ADD_nB;  

ARCHITECTURE arch_ADD_nB of ADD_nB IS

BEGIN

	process (a,b,Reset)
	variable Sum_inter : std_logic_vector ((NB_BITS-1) downto 0);

	begin
		if Reset = '1' then 
				Sum_inter := (others=>'0');
		else
			Sum_inter := a+b;		
			if a(NB_BITS-1) ='0' and b(NB_BITS-1) ='0'  and Sum_inter(NB_BITS-1) = '1' then
				Sum_inter := (others =>'1');
				Sum_inter(NB_BITS-1) := '0'; 
				
			elsif a(NB_BITS-1) ='1' and b(NB_BITS-1) ='1'  and Sum_inter(NB_BITS-1) = '0' then 
				Sum_inter := (others =>'0');	
				Sum_inter(NB_BITS-1) := '1';	
			end if;
		end if;
		Sum <= Sum_inter ;
	end process;

END arch_ADD_nB ;





