--------------------------------------
-- Multiplieur nbit
--------------------------------------

-- Declaration des bibliotheques -----
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;


-- Entit ----------------------------
entity MUL_nB is
	generic( NB_BITS : integer := 12);
	port(	a: in std_logic_vector(NB_BITS-1 downto 0);
			b   : in std_logic_vector(NB_BITS-1 downto 0);
			Reset : in std_logic;
			Prod : out std_logic_vector(2*NB_BITS-1 downto 0));
end MUL_nB;  

ARCHITECTURE arch_MUL_nB of MUL_nB IS
BEGIN

	process (a,b,Reset)
		variable Prod_inter : std_logic_vector ((2*NB_BITS-1) downto 0);
		begin
		if Reset = '1' then 
			Prod_inter := (others => '0');
		else 	
			Prod_inter := a*b;
			Prod_inter:= Prod_inter(2*NB_BITS-2 downto 0) & '0';		 
		end if;

		Prod <= Prod_inter;

	end process;
	
END arch_MUL_nB ;






