library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity ADD is
    generic(width : integer := 28);
	port (
				A, B  : in  STD_LOGIC_VECTOR(width-1 downto 0); -- A + B et Cout
				S     : out STD_LOGIC_VECTOR(width-1 downto 0) --Sortie et Carrie
	);	
end ADD;

architecture Behavioral of ADD is

component FA
	port (
				A, B, Cin  : in  STD_LOGIC; -- A + B + Cin
				S, Cout    : out STD_LOGIC --Sortie et Carrie
			);	
end component;

signal Sint, Cint : STD_LOGIC_VECTOR(width-1 downto 0);

begin

    Global: for i in 0 to width generate
        G0: if(i = 0 ) generate
            FA0  : FA port map(A => A(i)  ,B=> B(i)  ,Cin => '0'    ,S => Sint(i)  ,Cout => Cint(i));
        end generate G0;
        G1: if ((i>0) and (i<width)) generate
            FA1 : FA port map(A => A(i)  ,B=> B(i)  ,Cin => Cint(i-1)  ,S => Sint(i)  ,Cout => Cint(i));
        end generate G1;        
    end generate Global; 

	S <= Sint;
end Behavioral;

