library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity Compteur is
generic (width : integer := 16);
port(
		clk : in STD_LOGIC;
		en : in std_logic;
		rez : STD_LOGIC_VECTOR (width-1 downto 0);
		cptOut 	: out  STD_LOGIC_VECTOR (width-1 downto 0)
	);

end Compteur;

architecture Behavioral of Compteur is

--Component--
Component ADD
    generic(width : integer := 16);
	port (
		  A, B  : in  STD_LOGIC_VECTOR(width-1 downto 0); -- A + B et Cout
		  S     : out STD_LOGIC_VECTOR(width-1 downto 0) --Sortie et Carrie
	   );	
end Component;

Component Reg
        generic(width : integer := 16);
		Port ( 
				clk   : in STD_LOGIC;
				RESET : in  STD_LOGIC; 
				EN    : in STD_LOGIC; 
				div	: in STD_LOGIC_VECTOR(width-1 downto 0); --100M = 5F5E100 soit 1 seconde 2faf080 pour 0.5 (plus rapide)                                
				D		: in STD_LOGIC_VECTOR(width-1 downto 0);
				Q     : out STD_LOGIC_VECTOR(width-1 downto 0)
				);
end Component;

--Signal--
signal RegOut : STD_LOGIC_VECTOR(width-1 downto 0);
signal RegIn  : STD_LOGIC_VECTOR(width-1 downto 0);
signal Bin : STD_LOGIC_VECTOR(width-1 downto 0);

begin

	ADD0 : ADD generic map(width) port map(A => RegOut ,B => (0=>'1',others=>'0') ,S => RegIn);
	Reg0 : Reg generic map(width)  port map(clk => clk, reset => '1',en => en ,div => rez,D => RegIn, Q => RegOut);

cptOut <= RegOut;
		
end Behavioral;