library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Reg is
        Generic (width : integer := 28);
		Port ( 
				clk   : in STD_LOGIC;
				RESET : in  STD_LOGIC; -- Bouton rouge
				EN    : in STD_LOGIC; --BTNC	
				div	: in STD_LOGIC_VECTOR(width-1 downto 0); --100M = 5F5E100 soit 1 seconde 2faf080 pour 0.5 (plus rapide)
				D		: in STD_LOGIC_VECTOR(width-1 downto 0);
				Q     : out STD_LOGIC_VECTOR(width-1 downto 0));

end Reg;

architecture Behavioral of Reg is

begin

process(clk, RESET)
begin
	if(RESET = '0')then
		Q <= (others => '0');
		
	elsif(clk'event and clk ='1') then
		if(EN = '1') then
			if(D = div)then --100M = 5F5E100 soit 1 seconde 2faf080 pour 0.5 (plus rapide)
				Q <= (others => '0');
			else
				Q <= D;
			end if;
		end if;
	end if;
end process;

end Behavioral;

